﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using AzImageModes;

namespace AzImageModeApplication
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    
                    pictureBox1.Image = Image.FromFile(openFileDialog1.FileName);
                    
                }
                catch (NotSupportedException ex)
                {
                    MessageBox.Show("Image format is not supported: " + ex.Message, "Error",
                        MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                catch (ArgumentException ex)
                {
                    MessageBox.Show("Invalid image: " + ex.Message, "Error",
                        MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
                catch
                {
                    MessageBox.Show("Failed loading the image", "Error",
                        MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            string fn = openFileDialog1.FileName + "DIR";
            label2.Text = fn;
            System.IO.Directory.CreateDirectory(fn);
            
            
        }

        private void button2_Click(object sender, EventArgs e)
        {
            RGB rgb = new RGB((Bitmap)pictureBox1.Image);
            pictureBox2.Image = rgb.RedBand;
            label3.Text = "Red";
            pictureBox3.Image = rgb.GreenBand;
            label4.Text = "Green";
            pictureBox4.Image = rgb.BlueBand;
            label5.Text = "Blue";

            histogramaDesenat1.DrawHistogram(rgb.RedHistogram);
            histogramaDesenat2.DrawHistogram(rgb.GreenHistogram);
            histogramaDesenat3.DrawHistogram(rgb.BlueHistogram);

        }

        private void button6_Click(object sender, EventArgs e)
        {
            string fn = label2.Text;
            Bitmap bm = new Bitmap(pictureBox1.Image);
            bm.Save(fn + "\\00 Original Image.jpg");
            bm = new Bitmap(pictureBox2.Image);
            bm.Save(fn + "\\" + label3.Text + ".jpg");
            bm = new Bitmap(pictureBox3.Image);
            bm.Save(fn + "\\" + label4.Text + ".jpg");
            bm = new Bitmap(pictureBox4.Image);
            bm.Save(fn + "\\" + label5.Text + ".jpg");
            
            Rectangle rec = new Rectangle(0, 0, 160, 147);
            Bitmap temp = new Bitmap(160, 147);
            histogramaDesenat1.DrawToBitmap(temp, rec);
            temp.Save(fn + "\\Hist " + label3.Text + ".jpg");
            histogramaDesenat2.DrawToBitmap(temp, rec);
            temp.Save(fn + "\\Hist " + label4.Text + ".jpg");
            histogramaDesenat3.DrawToBitmap(temp, rec);
            temp.Save(fn + "\\Hist " + label5.Text + ".jpg");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            HSV h = new HSV((Bitmap)pictureBox1.Image);

            pictureBox2.Image = h.HueBand;
            label3.Text = "Hue";
            pictureBox3.Image = h.SaturationBand;
            label4.Text = "Saturation";
            pictureBox4.Image = h.BrightnessBand;
            label5.Text = "value";

            histogramaDesenat1.DrawHistogram(h.HueHistogram);
            histogramaDesenat2.DrawHistogram(h.SaturationHistogram);
            histogramaDesenat3.DrawHistogram(h.BrightnessHistogram);

        }

        private void button4_Click(object sender, EventArgs e)
        {
            XYZ xyz = new XYZ((Bitmap)pictureBox1.Image);

             pictureBox2.Image = xyz.XBand;
            label3.Text = "X";
            pictureBox3.Image = xyz.YBand;
            label4.Text = "Y";
            pictureBox4.Image = xyz.ZBand;
            label5.Text = "Z";

            histogramaDesenat1.DrawHistogram(xyz.XHistogram);
            histogramaDesenat2.DrawHistogram(xyz.YHistogram);
            histogramaDesenat3.DrawHistogram(xyz.ZHistogram);

        }

        private void button5_Click(object sender, EventArgs e)
        {
            LUV luv = new LUV((Bitmap)pictureBox1.Image);

             pictureBox2.Image = luv.LBand;
            label3.Text = "L";
            pictureBox3.Image = luv.UBand;
            label4.Text = "U";
            pictureBox4.Image =luv.VBand ;
            label5.Text = "V";

            histogramaDesenat1.DrawHistogram(luv.LHistogram);
            histogramaDesenat2.DrawHistogram(luv.UHistogram);
            histogramaDesenat3.DrawHistogram(luv.VHistogram);
        }
    }
}
